Skip to main content


Eclipse Community Forums
Forum Search:

Search      Help    Register    Login    Home
Home » Eclipse Projects » Plugin Development Environment (PDE) » OSGI Bundle Build failure only when exporting for deployment
OSGI Bundle Build failure only when exporting for deployment [message #65563] Thu, 25 June 2009 06:29 Go to next message
bank kus is currently offline bank kusFriend
Messages: 13
Registered: July 2009
Junior Member
I have a plain vanilla OSGI bundle with a bunch of import-packages on
other packages. The dependencies are fairly simple:

Bundle D
|________ import package A[1.0.0, 2.0.0)
|________ import package B[2.0.0, 3.0.0)
|____________________ import package
X[3.0.0, 4.0.0)

|________ import package X[2.0.0, 3.0.0)

As you can see D directly uses X(2.0.0) and indirectly via B uses X(3.0.0)

All this is good, I can build locally and run the OSGI bundle. But when I
hit Export->Plug-in Development ->Deployable Plugins and Fragments it
complaints of a build error.

The build error shows that its trying to build Bundle D using X(3.0.0) and
not X(2.0.0)

Is this a known problem / should I file a bug or are there subtle details
that I m missing.

Regards
banks
Re: OSGI Bundle Build failure only when exporting for deployment [message #65627 is a reply to message #65563] Thu, 25 June 2009 14:42 Go to previous messageGo to next message
Andrew Niefer is currently offline Andrew NieferFriend
Messages: 990
Registered: July 2009
Senior Member
You should raise a bug on PDE/Build for this.

You are going to end up with both providers of X on your build-time
classpath (the compiler may need X_3.0.0 due to references from B).
Build is going to generate access rules for each classpath entry telling
the compiler what D can use.

However, when we build the list of packages you are allowed to see, we
map the exporter's symbolic name to provided packages without
considering the version. So in the context of D, when we look up
packages provided by X_3.0.0 we get the list that would have been
provided by X_2.0.0 instead of the expected empty list of packages.

-Andrew
bank kus wrote:
> I have a plain vanilla OSGI bundle with a bunch of import-packages on
> other packages. The dependencies are fairly simple:
>
> Bundle D
> |________ import package A[1.0.0, 2.0.0)
> |________ import package B[2.0.0, 3.0.0)
> |____________________ import
> package X[3.0.0, 4.0.0)
>
> |________ import package X[2.0.0, 3.0.0)
>
> As you can see D directly uses X(2.0.0) and indirectly via B uses X(3.0.0)
>
> All this is good, I can build locally and run the OSGI bundle. But when
> I hit Export->Plug-in Development ->Deployable Plugins and Fragments it
> complaints of a build error.
>
> The build error shows that its trying to build Bundle D using X(3.0.0)
> and not X(2.0.0)
>
> Is this a known problem / should I file a bug or are there subtle
> details that I m missing.
>
> Regards
> banks
>
Re: OSGI Bundle Build failure only when exporting for deployment [message #65759 is a reply to message #65627] Fri, 26 June 2009 01:02 Go to previous message
bank kus is currently offline bank kusFriend
Messages: 13
Registered: July 2009
Junior Member
Done, https://bugs.eclipse.org/bugs/show_bug.cgi?id=281592

Regards
banks

> You should raise a bug on PDE/Build for this.
Re: OSGI Bundle Build failure only when exporting for deployment [message #598571 is a reply to message #65563] Thu, 25 June 2009 14:42 Go to previous message
Andrew Niefer is currently offline Andrew NieferFriend
Messages: 990
Registered: July 2009
Senior Member
You should raise a bug on PDE/Build for this.

You are going to end up with both providers of X on your build-time
classpath (the compiler may need X_3.0.0 due to references from B).
Build is going to generate access rules for each classpath entry telling
the compiler what D can use.

However, when we build the list of packages you are allowed to see, we
map the exporter's symbolic name to provided packages without
considering the version. So in the context of D, when we look up
packages provided by X_3.0.0 we get the list that would have been
provided by X_2.0.0 instead of the expected empty list of packages.

-Andrew
bank kus wrote:
> I have a plain vanilla OSGI bundle with a bunch of import-packages on
> other packages. The dependencies are fairly simple:
>
> Bundle D
> |________ import package A[1.0.0, 2.0.0)
> |________ import package B[2.0.0, 3.0.0)
> |____________________ import
> package X[3.0.0, 4.0.0)
>
> |________ import package X[2.0.0, 3.0.0)
>
> As you can see D directly uses X(2.0.0) and indirectly via B uses X(3.0.0)
>
> All this is good, I can build locally and run the OSGI bundle. But when
> I hit Export->Plug-in Development ->Deployable Plugins and Fragments it
> complaints of a build error.
>
> The build error shows that its trying to build Bundle D using X(3.0.0)
> and not X(2.0.0)
>
> Is this a known problem / should I file a bug or are there subtle
> details that I m missing.
>
> Regards
> banks
>
Re: OSGI Bundle Build failure only when exporting for deployment [message #598620 is a reply to message #65627] Fri, 26 June 2009 01:02 Go to previous message
bank kus is currently offline bank kusFriend
Messages: 13
Registered: July 2009
Junior Member
Done, https://bugs.eclipse.org/bugs/show_bug.cgi?id=281592

Regards
banks

> You should raise a bug on PDE/Build for this.
Previous Topic:PDE API Tooling
Next Topic:PDE Core refuses to be installed
Goto Forum:
  


Current Time: Wed Jun 16 21:10:52 GMT 2021

Powered by FUDForum. Page generated in 0.01821 seconds
.:: Contact :: Home ::.

Powered by: FUDforum 3.0.2.
Copyright ©2001-2010 FUDforum Bulletin Board Software

Back to the top